{% extends 'base.html' %}

{% block content %}
  <script src="https://cdn.jsdelivr.net/npm/chart.js@^4"></script>
  <script src="https://cdn.jsdelivr.net/npm/moment@^2"></script>
  <script src="https://cdn.jsdelivr.net/npm/chartjs-adapter-moment@^1"></script>
  <script src="https://cdn.jsdelivr.net/npm/chartjs-plugin-annotation@3.0.1"></script>
  <script src="https://cdn.jsdelivr.net/npm/axios@1"></script>

  <p class="h1">{% block title %} History {% endblock %}</p>

  <div class="row">
    <div class="col">
      <div class="input-group">
        <form action="{{ url_for('historypage')}}" method="get" id="form1">
          <div class="form-group">
            {% for station in stations %}
            <input type="radio" id="dgt" name="stationid" value={{ station }} {{ 'checked' if station_id==station else '' }}>
            <label for="dgt">{{ stations[station] }}</label><br>
            {% endfor %}
          </div>
        </form>
      </div>
    </div>
  </div>
  <div class="vr"></div>
  <div class="row">
    <div class="col col-sm">
      <div class="row" style="height: 280px">
        <canvas id="accuracyChart"></canvas>
      </div>
      <div class="row">
        <p class="text-center" id="totalInfo">Accuracy excluding Minor delays</p>
      </div>
      <div class="row" style="height: 180px">
        <canvas id="noOfTrainsChart"></canvas>
      </div>
      <div class="row">
        <p class="text-center" id="totalInfo">Total trains</p>
      </div>
    </div>
  </div>

<script>
    var accuracyConfig = {
      type: 'line',
      data: {
        labels: [],
        datasets: [{
          data: [],
        }]
      },
      options: {
        responsive: true,
        maintainAspectRatio: false,
        plugins: {
          legend: {
            display: false
          }
        },
        scales: {
          y: {
            type: 'linear',
            display: true,
            suggestedMin: 0,
            suggestedMax: 100,
            title: {
              display: true,
              text: 'Accuracy %'
            }
          }
        }
      }
    }
    var noOfTrainsConfig = {
      type: 'line',
      data: {
        labels: [],
        datasets: [{
          data: [],
        }]
      },
      options: {
        responsive: true,
        maintainAspectRatio: false,
        plugins: {
          legend: {
            display: false
          },
          scales: {
            y: {
              type: 'linear',
              display: true,
              suggestedMin: 0,
              title: {
                display: true,
                text: 'No of trains'
              }
            }
          }
        }
      }
    }

    document.getElementById("form1").onchange = function() { 
      document.getElementById("form1").submit(); 
    }

    function getFilters() {
      const urlParams = new URLSearchParams(window.location.search)
      let joinChar = '?'
      let filters = ""
      if (urlParams.has('stationid')) {
        filters = joinChar + 'stationid=' + urlParams.get('stationid')
        joinChar = "&"
      }
      return filters
    }

    function formatMinutes(duration) {
      //Duration is in minutes 4.333
      if (duration == 0) {
        return "No"
      }
      return duration.toFixed(1) + "mins average"
    }

    function getData() {
      getStats()
    }
    
    function getStats() {
      const noOfTrainsCtx = document.getElementById('noOfTrainsChart');
      window.noOfTrainsChart = new Chart(noOfTrainsCtx, noOfTrainsConfig);
      const accuracyCtx = document.getElementById('accuracyChart');
      window.accuracyChart = new Chart(accuracyCtx, accuracyConfig);

      let filters = getFilters()

      const start_generation = performance.now();
      axios.get(`/api/history${filters}`)
      .then(function (response) {
        if ('metrics' in response.data) {
          Object.entries(response.data.metrics).forEach(([year,v]) => {
            Object.entries(response.data.metrics[year]).forEach(([week,v2]) => {
              noOfTrainsConfig.data.labels.push(year + "." + week)
              noOfTrainsConfig.data.datasets[0].data.push(v2.totals.total)
              accuracyConfig.data.labels.push(year + "." + week)
              accuracyConfig.data.datasets[0].data.push(v2.accuracy.without_minor)
            })
          })
          window.noOfTrainsChart.update()
          window.accuracyChart.update()
        }
      })
      .catch(function (error) {
          console.error("Error retrieving statistics");
          console.error(error);
      })
      .finally(function () {
        console.log(`Took ${((performance.now() - start_generation)/1000).toFixed(2)} seconds to get statistics`);
      })
    }

    if (window.location.hostname == "localhost") {
      axios.defaults.baseURL = window.location.origin;
    } else if (window.location.port == "") {
      axios.defaults.baseURL = window.location.origin + "/rail";
    } else {
      axios.defaults.baseURL = window.location.origin;
    }
    window.onload = getData()
</script> 

{% endblock %}
